<!--
 Copyright © VNG Realisatie 2023
 Licensed under the EUPL
-->

{{ define "content" }}
    <div class="contracts-page">
        <div class="alert alert--warning">
            <p class="alert__content">
                {{ i18n "This page is intended for power users. We recommend using the wizards and pages throughout the Controller to help you manage the Contracts." }}
            </p>
        </div>

        <br />

        <div class="contracts-page__actions-bar">
            <form
                action="/contracts"
                method="get"
                hx-get="/contracts"
                hx-params="*"
                hx-push-url="true"
                hx-trigger="change"
                hx-target="body"
                hx-indicator=".contracts-page"
            >
                <div class="select">
                    <select name="grant_type" id="grant_type">
                        <option value="">{{ i18n "All Grant Types" }}</option>

                        {{ range $value, $label := .GrantTypeFilters }}
                            <option
                                value="{{ $value }}"
                                {{ if (eq $value $.GrantType) }}
                                    selected
                                {{ end }}
                            >
                                {{ $label }}
                            </option>
                        {{ end }}
                    </select>
                </div>
            </form>

            <a href="/contracts/add" class="button--primary">
                {{ svg "icon-plus" "icon--inline" }}
                {{ i18n "Add contract" }}
            </a>
        </div>

        <div class="contracts-page__loaded-content">
            {{ if and (eq (len .Contracts) 0) (not .PaginationNextCursor) }}
                <div class="contracts-page__no-results">
                    {{ i18n "No Contracts available" }}
                </div>
                <div id="pagination"></div>
            {{ else if and (eq (len .Contracts) 0) (.PaginationNextCursor) }}
                <div id="pagination">
                    <div class="contracts-page__no-results">
                        {{ i18n "No more Contracts available" }}.
                        <a href="/contracts?grant_type={{ .GrantType }}"
                            >{{ i18n "Back to top" }}.</a
                        >
                    </div>
                </div>
            {{ else }}
                <div id="contracts">
                    {{ range $contract := .Contracts }}
                        <div class="contract">
                            <h3 class="contracts-page__contract-title" hx-boost>
                                {{ block "contract-status" . }}{{ end }}


                                <a href="/contract/{{ $contract.Hash }}"
                                    >{{ $contract.IV }}</a
                                >
                            </h3>

                            {{ if gt (len $contract.ServicePublicationGrants) 0 }}
                                <table class="contracts-page__grants-table">
                                    <thead>
                                        <tr>
                                            <th>{{ i18n "Grant Type" }}</th>
                                            <th>{{ i18n "Directory" }}</th>
                                            <th>{{ i18n "Service Peer" }}</th>
                                            <th>{{ i18n "Service Name" }}</th>
                                            <th>{{ i18n "Created At" }}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {{ range $contract.ServicePublicationGrants }}
                                            <tr>
                                                <td>
                                                    {{ i18n "Service Publication" }}
                                                </td>
                                                <td>
                                                    {{ .DirectoryPeerName }}<br /><small
                                                        >{{ .DirectoryPeerID }}</small
                                                    >
                                                </td>
                                                <td>
                                                    {{ .ServicePeerName }}<br /><small
                                                        >{{ .ServicePeerID }}</small
                                                    >
                                                </td>
                                                <td>{{ .ServiceName }}</td>
                                                <td>
                                                    <time
                                                        datetime="{{ $contract.CreatedAt }}"
                                                    >
                                                        {{ $contract.CreatedAt }}
                                                    </time>
                                                </td>
                                            </tr>
                                        {{ end }}
                                    </tbody>
                                </table>
                            {{ end }}

                            {{ if gt (len $contract.ServiceConnectionGrants) 0 }}
                                <table class="contracts-page__grants-table">
                                    <thead>
                                        <tr>
                                            <th>{{ i18n "Grant Type" }}</th>
                                            <th>{{ i18n "Service Peer" }}</th>
                                            <th>{{ i18n "Service Name" }}</th>
                                            <th>{{ i18n "Outway Peer" }}</th>
                                            <th>
                                                {{ i18n "Outway Public Key Thumbprint" }}
                                            </th>
                                            <th>{{ i18n "Created At" }}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {{ range $contract.ServiceConnectionGrants }}
                                            <tr>
                                                <td>
                                                    {{ i18n "Service Connection" }}
                                                </td>
                                                <td>
                                                    {{ .ServicePeerName }}<br /><small
                                                        >{{ .ServicePeerID }}</small
                                                    >
                                                </td>
                                                <td>{{ .ServiceName }}</td>
                                                <td>
                                                    {{ .OutwayPeerName }}<br /><small
                                                        >{{ .OutwayPeerID }}</small
                                                    >
                                                </td>
                                                <td>
                                                    {{ .OutwayPublicKeyThumbprint }}
                                                </td>
                                                <td>
                                                    <time
                                                        datetime="{{ $contract.CreatedAt }}"
                                                    >
                                                        {{ $contract.CreatedAt }}
                                                    </time>
                                                </td>
                                            </tr>
                                        {{ end }}
                                    </tbody>
                                </table>
                            {{ end }}

                            {{ if gt (len $contract.DelegatedServicePublicationGrants) 0 }}
                                <table class="contracts-page__grants-table">
                                    <thead>
                                        <tr>
                                            <th>{{ i18n "Grant Type" }}</th>
                                            <th>{{ i18n "Directory" }}</th>
                                            <th>{{ i18n "Delegator" }}</th>
                                            <th>{{ i18n "Service Peer" }}</th>
                                            <th>{{ i18n "Service Name" }}</th>
                                            <th>{{ i18n "Created At" }}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {{ range $contract.DelegatedServicePublicationGrants }}
                                            <tr>
                                                <td>
                                                    {{ i18n "Delegated Service Publication" }}
                                                </td>
                                                <td>
                                                    {{ .DirectoryPeerName }}<br /><small
                                                        >{{ .DirectoryPeerID }}</small
                                                    >
                                                </td>
                                                <td>
                                                    {{ .DelegatorPeerName }}<br /><small
                                                        >{{ .DelegatorPeerID }}</small
                                                    >
                                                </td>
                                                <td>
                                                    {{ .ServicePeerName }}<br /><small
                                                        >{{ .ServicePeerID }}</small
                                                    >
                                                </td>
                                                <td>{{ .ServiceName }}</td>
                                                <td>
                                                    <time
                                                        datetime="{{ $contract.CreatedAt }}"
                                                    >
                                                        {{ $contract.CreatedAt }}
                                                    </time>
                                                </td>
                                            </tr>
                                        {{ end }}
                                    </tbody>
                                </table>
                            {{ end }}

                            {{ if gt (len $contract.DelegatedServiceConnectionGrants) 0 }}
                                <table class="contracts-page__grants-table">
                                    <thead>
                                        <tr>
                                            <th>{{ i18n "Grant Type" }}</th>
                                            <th>{{ i18n "Service Peer" }}</th>
                                            <th>{{ i18n "Service Name" }}</th>
                                            <th>{{ i18n "Outway Peer" }}</th>
                                            <th>
                                                {{ i18n "Outway Public Key Thumbprint" }}
                                            </th>
                                            <th>{{ i18n "Created At" }}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {{ range $contract.DelegatedServiceConnectionGrants }}
                                            <tr>
                                                <td>
                                                    {{ i18n "Delegated Service Connection" }}
                                                </td>
                                                <td>
                                                    {{ .ServicePeerName }}<br /><small
                                                        >{{ .ServicePeerID }}</small
                                                    >
                                                </td>
                                                <td>{{ .ServiceName }}</td>
                                                <td>
                                                    {{ .OutwayPeerName }}<br /><small
                                                        >{{ .OutwayPeerID }}</small
                                                    >
                                                </td>
                                                <td>
                                                    {{ .OutwayPublicKeyThumbprint }}
                                                </td>
                                                <td>
                                                    <time
                                                        datetime="{{ $contract.CreatedAt }}"
                                                    >
                                                        {{ $contract.CreatedAt }}
                                                    </time>
                                                </td>
                                            </tr>
                                        {{ end }}
                                    </tbody>
                                </table>
                            {{ end }}
                        </div>
                    {{ end }}
                </div>

                <br />
                <br />

                <nav>
                    <ol id="pagination" class="pagination" hx-boost="true">
                        <li>
                            <a
                                href="/contracts?pagination_cursor={{ .PaginationNextCursor }}&grant_type={{ .GrantType }}"
                                hx-select="#contracts .contract"
                                hx-target="#contracts"
                                hx-swap="beforeend show:none"
                                hx-select-oob="#pagination"
                                >{{ i18n "Show more Contracts" }}</a
                            >
                        </li>
                    </ol>
                </nav>
            {{ end }}
            <br />
        </div>

        <p
            class="contracts-page__loading-message loading-message"
            role="progressbar"
        >
            {{ svg "icon-spinner" "loading-message__spinner icon--inline" }}
            {{ i18n "Loading…" }}
        </p>
    </div>
{{ end }}
